//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1  DeepSkyBlue
#property indicator_color2  DimGray
#property indicator_color3  PaleVioletRed
#property indicator_color4  DeepSkyBlue
#property indicator_color5  DimGray
#property indicator_color6  PaleVioletRed
#property indicator_color7  Silver
#property indicator_color8  Silver
#property indicator_style2  STYLE_DOT
#property indicator_style4  STYLE_DOT
#property indicator_style5  STYLE_DOT
#property indicator_style6  STYLE_DOT
#property indicator_style8  STYLE_DOT
#property indicator_width7  2

//
//
//
//
//

extern int    BandsPrice       = 8;
extern int    DeviationsPeriod = 7;
extern int    SwingCount       = 5;
extern double Speed            = 1.0;
extern int    FutureBars       = 100;

//
//
//
//
//

double bandup[];
double banddn[];
double bandmi[];
double banfup[];
double banfdn[];
double banfmi[];
double lrvalue[];
double lrforecast[];
double swingBuffer[];

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

int init()
{
   SetIndexBuffer(0,bandup);
   SetIndexBuffer(1,bandmi);
   SetIndexBuffer(2,banddn);
   SetIndexBuffer(3,banfup);
   SetIndexBuffer(4,banfmi);
   SetIndexBuffer(5,banfdn);
   SetIndexBuffer(6,lrvalue);
   SetIndexBuffer(7,lrforecast);
   return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,k,n,limit,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArraySize(swingBuffer)!=Bars) ArrayResize(swingBuffer,Bars);

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--) 
   {
      int swing = 0;
         if (High[i]>High[i+1] && High[i+1]>High[i+2] && Low[i+2] < Low[i+3] && Low[i+3] < Low[i+4]) swing = -1;
         if (Low[i] < Low[i+1] && Low[i+1] < Low[i+2] && High[i+2]>High[i+3] && High[i+3]>High[i+4]) swing =  1;
         swingBuffer[Bars-i-1] = swing;
            for (k=i,n=0; (k<Bars) && (n<SwingCount); k++) if(swingBuffer[Bars-k-1]!=0) n++;
               int BandsPeriod = MathMax(MathRound((k-i)/SwingCount/Speed),1);
   
       //
       //
       //
       //
       //
       
       double slope;      
       double linreg    = iLRValue(getPrice(BandsPrice,i),BandsPeriod,i,slope);
       double deviation = iDeviation(linreg,DeviationsPeriod,i);
         lrvalue[i] = linreg;
         if (i>Bars-1)
         {
            bandup[i] = linreg;
            banddn[i] = linreg;
            bandmi[i] = linreg;
            continue;
         }         
         
         //
         //
         //
         //
         //
         
         bandup[i] = bandup[i+1];
         bandmi[i] = bandmi[i+1];
         banddn[i] = banddn[i+1];
         if (linreg>bandup[i+1] || linreg<banddn[i+1])
         {
            bandup[i] = linreg+2.0*deviation;
            banddn[i] = linreg-2.0*deviation;
            bandmi[i] = linreg;
         }
         
         //
         //
         //
         //
         //
         
         if (i==0)
         {
               for (int cross=0; cross<FutureBars; cross++)
               {
                  double value = linreg+slope*cross;
                     if (value > bandup[0]) break;
                     if (value < banddn[0]) break;
               }
               for (k=0; k<=cross; k++)
               {
                  banfup[cross-k]     = bandup[0];
                  banfdn[cross-k]     = banddn[0];
                  banfmi[cross-k]     = bandmi[0];
                  lrforecast[cross-k] = linreg+slope*k;
               }                  
         }
   }
   
   SetIndexShift(3,cross); SetIndexDrawBegin(3,Bars-cross-1);
   SetIndexShift(4,cross); SetIndexDrawBegin(4,Bars-cross-1);
   SetIndexShift(5,cross); SetIndexDrawBegin(5,Bars-cross-1);
   SetIndexShift(7,cross); SetIndexDrawBegin(7,Bars-cross-1);
   return(0);
}


//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double getPrice(int type, int i)
{
   switch (type)
   {
      case 7 : return((Open[i]+High[i]+Low[i]+Close[i])/4.0);
      case 8 : return((Open[i]+High[i]+Low[i]+Close[i]+Close[i])/5.0);
      default : return(iMA(NULL,0,1,0,MODE_SMA,MathMax(MathMin(type,6),0),i));
   }
}

//
//
//
//
//

double workDev[];
double iDeviation(double value, double period, int r, bool isSample=false)
{
   if (ArraySize(workDev)!=Bars) ArrayResize(workDev,Bars); r = Bars-r-1;

   workDev[r] = value; if (r<period) return(0);   
   
   //
   //
   //
   //
   //
   
   double avg = 0; for (int k=0; k<period && (r-k); k++) avg += workDev[r-k]; avg /= period;
   double sum = 0; for (    k=0; k<period; k++) sum += MathPow((workDev[r-k]-avg),2);
   if (isSample)
         return(MathSqrt(sum/(period-1.0)));
   else  return(MathSqrt(sum/period));
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double workLr[];
double iLRValue(double value, int period, int r, double& slope)
{
   if (ArraySize(workLr)!=Bars) ArrayResize(workLr,Bars); r = Bars-r-1;
                 workLr[r] = value;
                 if (r<period) return(value);
                 
   //
   //
   //
   //
   //
                    
   double sumX    = period * (period-1) / 2.0;
   double sumXX   = period * (period-1) * (2.0 * period - 1.0) / 6.0;
   double divisor = MathPow(sumX,2.0) - period * sumXX;
   double SumXY   = 0;
   double SumY    = 0;

         for (int i=0; i<period; i++)
         {
            SumXY += i*workLr[r-i];
            SumY  +=   workLr[r-i];
         }
   
   //
   //
   //
   //
   //
   
   if( divisor != 0 ) 
         	slope = (period * SumXY - sumX * SumY)/divisor;
   else     slope = 0; 
   return((SumY-slope*sumX)/period + slope*(period-1));
}

